!= Program ArareInitData
!
! Authors::   SUGIYAMA Ko-ichiro (̰ϯ), ODAKA Masatsugu ()
! Version::   $Id: arare_init-data.f90,v 1.1 2011-03-02 01:37:18 sugiyama Exp $
! Tag Name::  $Name: arare4-20110302-3 $
! Copyright:: Copyright (C) GFD Dennou Club, 2006. All rights reserved.
! License::   See COPYRIGHT[link:../../COPYRIGHT]
!
!== Overview 
!
! ϳإǥ deepconv/arare. 
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!  * ϤϽవ̷.
!
!== Future Plans
!
!

program ArareInitData
  !
  !ϳإǥ deepconv/arare. 
  !

  !----- ⥸塼ɤ߹ ------

  !-----   , ʸ   ----
  use dc_types,       only : STRING
  use dc_string,      only : StoA

  !-----   å   -----
  use dc_message,     only: MessageNotify

  !  ޥɥ饤
  use argset,        only : argset_init  

  !-----    ⥸塼   -----
  !  ̷׻⥸塼
  use ChemCalc, only: ChemCalc_init
  use chemdata, only: chemdata_init

  !  MPI ν
  use mpiset,        only : mpii_init, mpii_end, myrank

  !  ϥե̾⥸塼
  use filesetmpi,    only : fileset_init, &
    &                       InitFile

  !  ǥХåϴ⥸塼
  use debugset,      only : debugset_init

  !  ִ⥸塼
  use timeset,       only : timeset_init, &
    &                       NstepLong, NstepShort, DelTimeLong, DelTimeShort, &
    &                       NstepDisp

  !  ʻ⥸塼 
  use gridset,       only : gridset_init, &
    &                       DimXMin, DimXMax, DimZMin, DimZMax, SpcNum

  !  ܾ⥸塼
  use basicset,      only : basicset_init, &
    &                       xz_DensBasicZ, xza_MixRtBasicZ, xz_PotTempBasicZ, &
    &                       xz_VelSoundBasicZ

  !  ѻʹ⥸塼
  use StorePotTemp,      only : StorePotTemp_init, StorePotTempClean, &
    &                           StorePotTempCond
  use StoreMixRt,        only : StoreMixRt_init, StoreMixRtClean, &
    &                           StoreMixRtCond, StoreMixRtFill1, StoreMixRtFill2
  use StoreBuoy,         only : StoreBuoy_init, StoreBuoyClean
  use StoreStab,         only : StoreStab_init, StoreStabClean
  use StoreMom,          only : StoreMom_Init, StoreMomClean

  !  롼⥸塼
  use moistset,      only: moistset_init

  !-----    ⥸塼   -----
  !  ໤׻⥸塼 
  use damping,       only : damping_init, & 
    &                        DampSponge_xz, DampSponge_pz, DampSponge_xr

  !  ʬե륿⥸塼
  use timefilter,    only : AsselinFilter_xz, AsselinFilter_xr, &
    &                        AsselinFilter_pz, AsselinFilter_xza

  !  Ŭѥ⥸塼
  use boundarympi,    only : BoundaryXCyc_xz, BoundaryZSym_xz,     &
    &                      BoundaryXCyc_xza, BoundaryZSym_xza,   &
    &                      BoundaryXCyc_pz, BoundaryZSym_pz,     &
    &                      BoundaryXCyc_xr, BoundaryZAntiSym_xr

  !  CFL ǧ⥸塼
  use cflcheck,      only : CFLCheckTimeShort, &
    &                       CFLCheckTimeLongVelX, CFLCheckTimeLongVelZ

  !  μ̤Ŷ׻⥸塼
  use fillnegative,  only : FillNegative_init, xza_FillNegative_xza

  !-----    ϥ⥸塼   -----
  !  ꥹȥեϥ⥸塼
  use RestartFileIOmpi, only : ReStartFile_Open, ReStartFile_OutPut, &
    &                       ReStartFile_Close, ReStartFile_Get, ReStartFile_Get2

  !  ҥȥեϥ⥸塼
  use HistoryFileIOmpi, only : HistoryFile_Open, HistoryFile_OutPut, &
    &                       HistoryFile_Close

  !-----       ϳز        -----
  !  ϳز׻Ѵؿ⥸塼
  use DynFunc,       only : xz_AdvScalar, xz_AdvKm, xza_AdvScalar, pz_AdvVelX, &
    &                       xr_Buoy, xr_AdvVelZ, pz_GradPi
  
  !  ϳزˡ׻Ѵؿ⥸塼
  use DynImpFunc,    only : xz_Exner_init, xz_Exner, xr_GradPi
  
  !-----       ʪ        -----
  !  ͳȻ׻ѥ⥸塼
  use NumDiffusion,  only : NumDiffusion_Init, xz_NumDiffScalar, xz_NumDiffKm, &
    &                       xza_NumDiffScalar, pz_NumDiffVelX, xr_NumDiffVelZ

  !  ήȻ׻ѥ⥸塼
  use Turbulence,   only : Turbulence_Init, &
    &                      xz_TurbScalar, xza_TurbScalar, pz_TurbVelX, &
    &                      xr_TurbVelZ  , xz_ShearKm    , xz_DispKm,   &
    &                      xz_DispHeat
  
  !  Ͷ׻ѥ⥸塼
  use Radiation,    only : Radiation_init,  &
    &                      xz_RadHeatConst  
  
  !  ɽեå׻ѥ⥸塼
!  use HeatFlux,     only : xz_HeatFluxBulk, xz_MixRtFluxBulk
  use HeatFlux,     only : xz_HeatFluxDiff, xza_MixRtFluxDiff

  !  ˰Ĵˡ׻ѥ⥸塼
  use MoistAdjust,  only : MoistAdjustSvapPress, MoistAdjustNH4SH

  !  ʪѥ᥿ꥼ
  use WarmRainPrm,  only : WarmRainPrm_Init, xz_Rain2GasHeat, xza_Rain2Gas, &
    &                      xza_Rain2GasNH4SH, xz_Rain2GasHeatNH4SH,         &
    &                      xza_Cloud2Rain, xza_FallRain

  !  ᵤϷ׻ѥ⥸塼
  use MoistBuoyancy,only : MoistBuoy_Init, xz_BuoyMoistKm, xr_BuoyMolWt, &
    &                      xr_BuoyDrag

  !  ٤η׻
  use ECCM, only: ECCM_Stab

  !ۤηػ
  implicit none

  !ѿ
  character(80) :: cfgfile
  real(8), allocatable :: pz_VelXBl(:,:)
  real(8), allocatable :: xr_VelZBl(:,:)
  real(8), allocatable :: xz_ExnerBl(:,:)
  real(8), allocatable :: xz_PotTempBl(:,:)
  real(8), allocatable :: xz_KmBl(:,:)
  real(8), allocatable :: xz_KhBl(:,:)
  real(8), allocatable :: xza_MixRtBl(:,:,:)
  real(8)              :: Time

  !ޥɥ饤β
  call mpii_init

  !NAMELIST ե̾ɤ߹
  if (myrank == 0) then 
    call MessageNotify( "M", "main", "Namelist file is '%c'", c1=trim(cfgfile) )
  end if
  call argset_init(cfgfile)

  !ǥХå
  call debugset_init(cfgfile, myrank)

  !ʪν
  call chemdata_init()

  !˴ؤν
  !  NAMELIST ɬפʾɤ߼, ִϢѿԤ. 
  call timeset_init(cfgfile)

  !ʻν
  !  NAMELIST , ʻ׻
  call gridset_init(cfgfile)

  !ط׻롼ν
  call chemcalc_init()
  
  !ܾξν
  !  NAMELIST , ܾꤹ.
  call basicset_init(cfgfile)
  
  !I/O ե̾ν
  !  NAMELIST ե̾ꤷ, deepconv/arare 
  !  ϥե̾ NAMELIST 
  call fileset_init(cfgfile)

  !롼ζͭѿν
  call moistset_init()

  !ѻͤݴɤ뤿Υ⥸塼ν
  !  NAMELIST , ܾꤹ.
  call StorePotTemp_init( )
  call StoreMixRt_init( )
  call StoreBuoy_init( )  
  call StoreStab_init( )  
  call StoreMom_init( )  

  !ѿν. ȤꤢͤꤵƤ. 
  call ArareAlloc

  !ǥեδܾ, . 
  call BasicEnv()  
  call DisturbEnvMPI(cfgfile,                         &
    & xz_PotTempBl, xz_ExnerBl, pz_VelXBl, xr_VelZBl, &
    & xza_MixRtBl,  xz_KmBl,    xz_KhBl               )
  
!  !----------------------------------------------------------------------
!  ! ѥå⥸塼ν
!  !   ǥեȤͤѹɬפΤ롼Τ߽
!  !----------------------------------------------------------------------
!  call Damping_Init( cfgfile )      !Ȥθ그ν
!!  call NumDiffusion_Init3( cfgfile ) !ͳȻν
!  call NumDiffusion_Init()          !ͳȻν
!  call Turbulence_Init()            !ή׻ν
!  call WarmRainPrm_Init( cfgfile )  !ȤΥѥ᥿ꥼν
!  call FillNegative_Init( xza_MixRtBasicZ, xz_DensBasicZ)
!  call Radiation_Init( cfgfile )    !Ͷν
!  call MoistBuoy_Init()             !ʬ̤ФϷ׻롼ν!
!  call xz_Exner_Init()              !ˡν  
       
  !----------------------------------------------------------------
  ! ꥹȥեκ
  !----------------------------------------------------------------
  call ReStartFile_Open( )
  call ReStartFile_OutPut(                            &
    & Time,                                           &
    & xz_PotTempBl, xz_ExnerBl, pz_VelXBl, xr_VelZBl, &
    & xza_MixRtBl,  xz_KmBl,    xz_KhBl               )
  call ReStartFile_Close
    
contains

  subroutine ArareAlloc
    !
    !Ȥ, , ͤȤƥ.
    !

    !ۤηػ
    implicit none

    !
    allocate(                                                  &
      & pz_VelXBl(DimXMin:DimXMax, DimZMin:DimZMax),           &
      & xr_VelZBl(DimXMin:DimXMax, DimZMin:DimZMax),           &
      & xz_ExnerBl(DimXMin:DimXMax, DimZMin:DimZMax),          &
      & xz_PotTempBl(DimXMin:DimXMax, DimZMin:DimZMax),        &
      & xz_KmBl(DimXMin:DimXMax, DimZMin:DimZMax),             &
      & xz_KhBl(DimXMin:DimXMax, DimZMin:DimZMax),             &
      & xza_MixRtBl(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum), &
      & DelTimeLFrog(NstepLong), NStepEular(NStepLong)         ) 

    pz_VelXBl = 0.0d0
    xr_VelZBl = 0.0d0
    xz_ExnerBl = 0.0d0
    xz_KmBl = 0.0d0
    xz_KhBl = 0.0d0
    xz_PotTempBl = 0.0d0
    xza_MixRtBl = 0.0d0
  end subroutine ArareAlloc
    
end program ArareInitData
